 /*
 * file      : src/stream.c
 * project   : tnt
 * with      : Gtk-3
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TNT - INDIQUEZ ICI CE QUE FAIT LE PROGRAMME
 * GNU General Public License
 *
 * This file is part of TNT.
 *
 * TNT is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * TNT is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TNT.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <glib.h>

#include <string.h>
#include <fcntl.h>	// PROCESSUS NON-BLOQUANT
#include <sys/ioctl.h>

#include <linux/dvb/frontend.h>
#include <linux/dvb/dmx.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_dvbtv/lib.h"
#endif

#include "global.h"
#include "stream.h"


// /dev/dvb/adapter0
// /dev/dvb/adapter0/demux0
// /dev/dvb/adapter0/dvr0
// /dev/dvb/adapter0/frontend0
// /dev/dvb/adapter0/net0
//
// /dev/dvb/adapter1
// /dev/dvb/adapter1/demux0
// /dev/dvb/adapter1/dvr0
// /dev/dvb/adapter1/frontend0
// /dev/dvb/adapter1/net0

/*
typedef struct {
	gchar	frontend[ 80 ];
	gchar	dvr[ 80 ];
	gchar	demux[ 80 ];
	gchar	name_type_fronted[ 80 ];
	struct dvb_frontend_info fe_info;
} ADAPTER;
*/
ADAPTER adapter;

void Stream_print( void )
{
	if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
		g_print( "\t---\n" );
		g_print( "\tadapter.frontend                      = %s\n", adapter.frontend );
		g_print( "\tadapter.dvr                           = %s\n", adapter.dvr );
		g_print( "\tadapter.demux                         = %s\n", adapter.demux );
		g_print( "\tadapter.name_type_fronted             = %s (%d)\n", adapter.name_type_fronted, adapter.fe_info.type );
		g_print( "\tadapter.fe_info.name                  = %s\n", adapter.fe_info.name );
		g_print( "\tadapter.fe_info.frequency_min         = %d\n", adapter.fe_info.frequency_min );
		g_print( "\tadapter.fe_info.frequency_max         = %d\n", adapter.fe_info.frequency_max );
		g_print( "\tadapter.fe_info.frequency_stepsize    = %d\n", adapter.fe_info.frequency_stepsize );
		g_print( "\tadapter.fe_info.frequency_tolerance   = %d\n", adapter.fe_info.frequency_tolerance );
		g_print( "\tadapter.fe_info.symbol_rate_min       = %d\n", adapter.fe_info.symbol_rate_min );
		g_print( "\tadapter.fe_info.symbol_rate_max       = %d\n", adapter.fe_info.symbol_rate_max );
		g_print( "\tadapter.fe_info.symbol_rate_tolerance = %d\n", adapter.fe_info.symbol_rate_tolerance );
		g_print( "\tadapter.fe_info.notifier_delay        = %d\n", adapter.fe_info.notifier_delay );
		g_print( "\tadapter.fe_info.caps                  = %d\n", adapter.fe_info.caps );
	}
}
gboolean Stream_scan( void )
{
	int		num_adapter;
	int		frontend_fd = -1;

	PRINT_FUNC_LF();

	for( num_adapter=0; num_adapter < 8; num_adapter++ ) {

		snprintf( adapter.frontend, sizeof(adapter.frontend), "/dev/dvb/adapter%d/frontend0", num_adapter );
		if( (frontend_fd = open( adapter.frontend, FE_OPEN_MODE )) < 0 )
			continue;
		if( ioctl( frontend_fd, FE_GET_INFO, &adapter.fe_info ) == -1 ) {
			close( frontend_fd );
			continue;
		}
		snprintf( adapter.dvr, sizeof(adapter.dvr), "/dev/dvb/adapter%d/dvr0", num_adapter );
		snprintf( adapter.demux, sizeof(adapter.demux), "/dev/dvb/adapter%d/demux0", num_adapter );

		switch( adapter.fe_info.type ) {
		case FE_OFDM: strcpy( adapter.name_type_fronted, "DVB-T" );	break;
		case FE_QAM:  strcpy( adapter.name_type_fronted, "DVB-C" );	break;
		case FE_QPSK: strcpy( adapter.name_type_fronted, "DVB-S" );	break;
		case FE_ATSC: strcpy( adapter.name_type_fronted, "DVB-ATSC" );	break;
		default: g_print("UNKNOWN TUNER TYPE\n" );
		}

		close( frontend_fd );
		return( TRUE );
	}
	return( FALSE );
}



